/*
 * Licensed Materials - Property of HCL
 * UrbanCode Deploy
 * (c) Copyright HCL Technologies Ltd. 2018. All Rights Reserved.
 */
import com.urbancode.air.AirPluginTool
import com.urbancode.air.ExitCodeException
import com.urbancode.air.plugin.ispw.versions.AssignmentClient

import org.apache.log4j.Level
import org.apache.log4j.Logger

AirPluginTool apTool = new AirPluginTool(this.args[0], this.args[1])
Properties props = apTool.getStepProperties()

String logLevel = props['loggerLevel']
Logger.getRootLogger().setLevel(Level.toLevel(logLevel))
Logger logger = Logger.getLogger(getClass())

String assignId = props['assignId'].trim()
String checkout = props['checkout'] // ISPW REST API accepts strings instead of boolean values

AssignmentClient assignClient = new AssignmentClient(props)
Map<String, String> responseMap

try {
    logger.info("Adding task to assignment with ID ${assignId}")
    responseMap = assignClient.addTask(assignId, checkout)
    logger.info("Successfully added task to assignment.")
}
/* Catch custom thrown exceptions */
catch (ExitCodeException ex) {
    logger.error(ex)    // Log error message and ignore custom stack trace
    System.exit(1)
}

if (responseMap != null && !responseMap.isEmpty()) {
    if (responseMap.containsKey("taskName")) {
        apTool.setOutputProperty("taskName", responseMap.id)
    }
    if (responseMap.containsKey("url")) {
        apTool.setOutputProperty("url", responseMap.url)
    }

    apTool.storeOutputProperties()
}